function get_altlatlon, x1, y1, z1, angle

; Paul Withers, 2001.07.03
; Open University, Britain

; Called by:				set_initial.pro, recon_traj.pro, 
;					derivs.pro, model_atm.pro
; Calls:				N/A
; Declares common blocks:		N/A
; Reads from:				N/A
; Writes to:				N/A
; Options:				N/A
; Purpose:				Transform positions from inertial 
;					cartesian frame to
; 					momentary spherical frame

new_coord = cv_coord(from_rect=[x1,y1,z1], /to_sphere)
z= new_coord(2)
; radial distance, not altitude

lat = new_coord(1) * double(180. /!pi)
lon = (new_coord(0) - angle) * double(180. /!pi)

; Want longitude in range 0 - 360 degrees
; Isn't one of these two lines redundant?
while lon lt 0 do lon = lon + double(360.)
lon = double(lon - fix(lon)/360 * 360.)

return, [z, lat, lon]
end


