pro maketable

; Paul Withers, 2004.09.10
; Center for Space Physics, Boston University

; Make nice table of MER EDL results at 2km intervals

common sctblk

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect
sct = sctpropsstruct.sct
r0 = sctpropsstruct.r0
outdir = sctpropsstruct.outdir

n = nchute - ndetect

prefix = outdir+'atm_'+sct+'_'
suffix1 = '_nominal.dat'
suffix2 = '_sigma.dat'

t = dblarr(n)
height = t
lat = t
lon = t
axial = t
normal = t
ca = t
cn = t
alpha = t
ma = t
kn = t
rho = t
press = t
temp = t

st = t
sheight = t
slat = t
slon = t
saxial = t
snormal = t
sca = t
scn = t
salpha = t
sma = t
skn = t
srho = t
spress = t
stemp = t


openr, lun1, prefix+'t'+suffix1, /get_lun
readf, lun1, t
free_lun, lun1

openr, lun1, prefix+'height'+suffix1, /get_lun
readf, lun1, height
free_lun, lun1

openr, lun1, prefix+'lat'+suffix1, /get_lun
readf, lun1, lat
free_lun, lun1

openr, lun1, prefix+'lon'+suffix1, /get_lun
readf, lun1, lon
free_lun, lun1

openr, lun1, prefix+'axial'+suffix1, /get_lun
readf, lun1, axial
free_lun, lun1

openr, lun1, prefix+'normal'+suffix1, /get_lun
readf, lun1, normal
free_lun, lun1

openr, lun1, prefix+'ca'+suffix1, /get_lun
readf, lun1, ca
free_lun, lun1

openr, lun1, prefix+'cn'+suffix1, /get_lun
readf, lun1, cn
free_lun, lun1

openr, lun1, prefix+'alpha'+suffix1, /get_lun
readf, lun1, alpha
free_lun, lun1

openr, lun1, prefix+'ma'+suffix1, /get_lun
readf, lun1, ma
free_lun, lun1

openr, lun1, prefix+'kn'+suffix1, /get_lun
readf, lun1, kn
free_lun, lun1

openr, lun1, prefix+'rho'+suffix1, /get_lun
readf, lun1, rho
free_lun, lun1

openr, lun1, prefix+'press'+suffix1, /get_lun
readf, lun1, press
free_lun, lun1

openr, lun1, prefix+'temp'+suffix1, /get_lun
readf, lun1, temp
free_lun, lun1


openr, lun1, prefix+'t'+suffix2, /get_lun
readf, lun1, st
free_lun, lun1

openr, lun1, prefix+'height'+suffix2, /get_lun
readf, lun1, sheight
free_lun, lun1

openr, lun1, prefix+'lat'+suffix2, /get_lun
readf, lun1, slat
free_lun, lun1

openr, lun1, prefix+'lon'+suffix2, /get_lun
readf, lun1, slon
free_lun, lun1

openr, lun1, prefix+'axial'+suffix2, /get_lun
readf, lun1, saxial
free_lun, lun1

openr, lun1, prefix+'normal'+suffix2, /get_lun
readf, lun1, snormal
free_lun, lun1

openr, lun1, prefix+'ca'+suffix2, /get_lun
readf, lun1, sca
free_lun, lun1

openr, lun1, prefix+'cn'+suffix2, /get_lun
readf, lun1, scn
free_lun, lun1

openr, lun1, prefix+'alpha'+suffix2, /get_lun
readf, lun1, salpha
free_lun, lun1

openr, lun1, prefix+'ma'+suffix2, /get_lun
readf, lun1, sma
free_lun, lun1

openr, lun1, prefix+'kn'+suffix2, /get_lun
readf, lun1, skn
free_lun, lun1

openr, lun1, prefix+'rho'+suffix2, /get_lun
readf, lun1, srho
free_lun, lun1

openr, lun1, prefix+'press'+suffix2, /get_lun
readf, lun1, spress
free_lun, lun1

openr, lun1, prefix+'temp'+suffix2, /get_lun
readf, lun1, stemp
free_lun, lun1


openw, lun1, 'suppinfo_'+sct+'table.dat', /get_lun

printf, lun1, '*** BEGIN PREAMBLE ***'
printf, lun1, '35 rows of preamble'
printf, lun1, strcompress(string(round(n)), /remove_all) + ' rows of data'
printf, lun1, '28 columns of data'
printf, lun1, 'Spacecraft is: ', sct
printf, lun1, 'time (s since last time that SCLK was divisible by 1E4)'
printf, lun1, '1 sigma uncertainty in t (s)'
printf, lun1, 'radial distance (m)'
printf, lun1, '1 sigma uncertainty in radial distance (m)'
printf, lun1, 'latitude (degN)'
printf, lun1, '1 sigma uncertainty in latitude (degN)'
printf, lun1, 'longitude (degE)'
printf, lun1, '1 sigma uncertainty in longitude (degE)'
printf, lun1, 'axial acceleration (ms-2)'
printf, lun1, '1 sigma uncertainty in axial acceleration'
printf, lun1, 'normal acceleration (ms-2)'
printf, lun1, '1 sigma uncertainty in normal acceleration'
printf, lun1, 'CA (dimensionless)'
printf, lun1, '1 sigma uncertainty in CA (dimensionless)'
printf, lun1, 'CN (dimensionless)'
printf, lun1, '1 sigma uncertainty in CN (dimensionless)'
printf, lun1, 'angle of attack (degrees)'
printf, lun1, '1 sigma uncertainty in angle of attack (degrees)'
printf, lun1, 'Mach number (dimensionless)'
printf, lun1, '1 sigma uncertainty in Ma (dimensionless)'
printf, lun1, 'Knudsen number (dimensionless)'
printf, lun1, '1 sigma uncertainty in Kn (dimensionless)'
printf, lun1, 'Density (kg m-3)'
printf, lun1, '1 sigma uncertainty in density (kg m-3)'
printf, lun1, 'Pressure (Pa)'
printf, lun1, '1 sigma uncertainty in pressure (Pa)'
printf, lun1, 'Temperature (K)'
printf, lun1, '1 sigma uncertainty in temperature (K)'
printf, lun1, 'Sequence is: t st r sr lat slat lon slon aa saa an san ca sca cn scn alpha salpha ma sma kn skn rho srho press spress temp stemp'
printf, lun1, '*** END PREAMBLE ***'
format = '(2F9.4,2E11.4,4F9.4,4E11.4,6F9.4,10E11.4)'
i=0
while i lt n do begin
printf, lun1, format=format, t(i), st(i), height(i), sheight(i), lat(i), slat(i), lon(i), slon(i), axial(i), saxial(i), normal(i), snormal(i), ca(i), sca(i), cn(i), scn(i), alpha(i), salpha(i), ma(i), sma(i), kn(i), skn(i), rho(i), srho(i), press(i), spress(i), temp(i), stemp(i)

i=i+1
endwhile

free_lun, lun1


stop





newz = dindgen(46)*2 + 10
oldz = (height-r0)/1e3

newt = interpol(t, oldz, newz)
newrho = exp(interpol(alog(rho), oldz, newz))
newpress = exp(interpol(alog(press), oldz, newz))
newtemp = interpol(temp, oldz, newz)
newaeroacc = exp(interpol(alog(aeroacc), oldz, newz))

format = '(F9.4,F9.4,E11.4,E11.4,F9.4,E11.4)'
openw, lun1, sct+'table.dat', /get_lun
printf, lun1, 'Begin preamble'
printf, lun1, '12 rows in preamble'
printf, lun1, '6 columns of data'
printf, lun1, '46 rows of data'
if sct eq 'mer1' then printf, lun1, 'Col 1: time in seconds since SCLK=128270000.000s'
if sct eq 'mer2' then printf, lun1, 'Col 1: time in seconds since SCLK=126460000.000s'
printf, lun1, 'Col 2: radial distance (km) - ' + get_sr0(r0)
printf, lun1, 'Col 3: density (kg m-3)'
printf, lun1, 'Col 4: pressure (Pa)'
printf, lun1, 'Col 5: temperature (K)'
printf, lun1, 'Col 6: magnitude of measured acceleration (m s-2)'
printf, lun1, 'IDL Format is ' + format
printf, lun1, 'End preamble'
i=0
while i lt n_elements(newz) do begin
printf, lun1, format=format, newt(i), newz(i), newrho(i), newpress(i), newtemp(i), newaeroacc(i)

;printf, lun1, newt(i), format='(F9.2)'
;t, r, T in decimal, rho, p, acc in exp
i=i+1
endwhile

free_lun, lun1
stop
end
