pro mericarus2005plots

; Paul Withers, 2005.06.01
; Center for Space Physics, Boston University

; Make plots for MER Icarus paper

common marsblk
; Properties of Mars and physical constants
; Defined in marsprops

common sctblk
; Properties of spacecraft and datasets
; Defined in sctprops

set_plot, 'ps'
device, /portrait, encapsulated=1, $
 color=1, filename='out.eps', /bold
 
!p.charsize=1.5
!p.charthick=2.0
!p.font=0
!p.thick=5.0
!x.thick=5.0
!y.thick=5.0
!z.thick=5.0
!p.multi=0
!x.ticklen=0.04
!y.ticklen=0.04

color=4
!p.thick=1
 
tvlct, [0,255,0,0,150,255,0,255,255,128,128], [0,0,255,0,150,255,255,0,255,128,0],$
 [0,0,0,255,150,255,255,255,0,0,128]
; 0,1,2,3,4,5 = K, R, G, B, grey, W
; 6,7,8,9,10 = C, M, Y, camogreen, bluey?
 
sct = sctpropsstruct.sct
n = sctpropsstruct.n
r0 = sctpropsstruct.r0
datafile = sctpropsstruct.datafile
outdir = sctpropsstruct.outdir
t0string = sctpropsstruct.t0string
sa = sctpropsstruct.sa
nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect
npadtop = sctpropsstruct.npadtop

blah=0
if blah ne 0 then begin
; Plot various a vs t

t_array = dblarr(n)
aeroaccsctx_array = t_array
aeroaccscty_array = t_array
aeroaccsctz_array = t_array
saeroaccsctx_array = t_array
saeroaccscty_array = t_array
saeroaccsctz_array = t_array

openr, lun1, datafile, /get_lun
readf, lun1, t_array
readf, lun1, aeroaccsctx_array
readf, lun1, aeroaccscty_array
readf, lun1, aeroaccsctz_array
readf, lun1, saeroaccsctx_array
readf, lun1, saeroaccscty_array
readf, lun1, saeroaccsctz_array
free_lun, lun1

n = sctpropsstruct.nchute

t_array = t_array(0:n-1)
aeroaccsctx_array = aeroaccsctx_array(0:n-1)
aeroaccscty_array = aeroaccscty_array(0:n-1)
aeroaccsctz_array = aeroaccsctz_array(0:n-1)
saeroaccsctx_array = saeroaccsctx_array(0:n-1)
saeroaccscty_array = saeroaccscty_array(0:n-1)
saeroaccsctz_array = saeroaccsctz_array(0:n-1)

!p.multi=[0,1,5]
device, xsize=4, ysize=10, /inch

if sct eq 'mer2' then xcoord = 2070
if sct eq 'mer1' then xcoord = 8170

xminor = 5
yminor = 5
plot, t_array, aeroaccsctx_array, yrange=[-1,1]*0.4, $
 ytitle = 'a!Dx!N (m s!U-2!N)', xtitle = 't!DSCLK!N (s) - '+t0string, $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [aeroaccsctx_array(i)-saeroaccsctx_array(i), aeroaccsctx_array(i)+saeroaccsctx_array(i), $
 aeroaccsctx_array(i+1)+saeroaccsctx_array(i+1), aeroaccsctx_array(i+1)-saeroaccsctx_array(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, t_array, aeroaccsctx_array
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, xcoord, 0.2, 'a'

xminor = 5
yminor = 5
plot, t_array, aeroaccscty_array, yrange=[-1,1]*0.4, $
 ytitle = 'a!Dy!N (m s!U-2!N)', xtitle = 't!DSCLK!N (s) - '+t0string, $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [aeroaccscty_array(i)-saeroaccscty_array(i), aeroaccscty_array(i)+saeroaccscty_array(i), $
 aeroaccscty_array(i+1)+saeroaccscty_array(i+1), aeroaccscty_array(i+1)-saeroaccscty_array(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, t_array, aeroaccscty_array
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, xcoord, 0.2, 'b'

an = sqrt(aeroaccsctx_array^2 + aeroaccscty_array^2)
sofansqd = sqrt( (2.*saeroaccsctx_array*aeroaccsctx_array)^2 + $ 
 (2.*saeroaccscty_array*aeroaccscty_array)^2 )
san = 0.5 * sofansqd / an

xminor = 5
yminor = 5
plot, t_array, an, yrange=[0,1]*0.4, $
 ytitle = 'a!Dn!N (m s!U-2!N)', xtitle = 't!DSCLK!N (s) - '+t0string, $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [an(i)-san(i), an(i)+san(i), an(i+1)+san(i+1), an(i+1)-san(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, t_array, an
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, xcoord, 0.3, 'c'

xminor = 5
yminor = -1
plot, t_array, aeroaccsctz_array, /ylog, yrange=[1e-3,1e2], $
 ytitle = 'a!Dz!N (m s!U-2!N)', xtitle = 't!DSCLK!N (s) - '+t0string, $
 ytickname=['10!U-3!N', '10!U-2!N', '10!U-1!N', '10!U0!N', '10!U1!N', '10!U2!N'], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
oplot, [-1,1]*1e10, 0.01*[1,1]
i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [aeroaccsctz_array(i)-saeroaccsctz_array(i), aeroaccsctz_array(i)+saeroaccsctz_array(i), $
 aeroaccsctz_array(i+1)+saeroaccsctz_array(i+1), aeroaccsctz_array(i+1)-saeroaccsctz_array(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, t_array, aeroaccsctz_array
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, xcoord, 1e1, 'd'

rat = an / aeroaccsctz_array
srat = rat * sqrt( (san/an)^2 + (saeroaccsctz_array/aeroaccsctz_array)^2 )

xminor = 5
yminor = 5
plot, t_array, rat, yrange=[0,2e-2], $
 ytitle = 'a!Dn!N / a!Dz!N', xtitle = 't!DSCLK!N (s) - '+t0string, $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [rat(i)-srat(i), rat(i)+srat(i), $
 rat(i+1)+srat(i+1), rat(i+1)-srat(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, t_array, rat
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, xcoord, 0.015, 'e'

; Do I want to space out so that wiggles on a_i can be seen?
; Do I want to add grey shading for uncert envelope - yes.

; 126462085.625
; 128278194.625

endif

blah=0
if blah ne 0 then begin

; Plot z vs t, and vrel, lat, lon vs z

t_array = dblarr(n)
height_array = t_array
vrel_array = t_array
lat_array = t_array
lon_array = t_array
st_array = t_array
sheight_array = t_array
svrel_array = t_array
slat_array = t_array
slon_array = t_array

openr, lun1, outdir + 'traj_' + sct + '_t_nominal.dat', /get_lun
readf, lun1, t_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_t_sigma.dat', /get_lun
readf, lun1, st_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_nominal.dat', /get_lun
readf, lun1, vrel_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_sigma.dat', /get_lun
readf, lun1, svrel_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_nominal.dat', /get_lun
readf, lun1, lat_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_sigma.dat', /get_lun
readf, lun1, slat_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_nominal.dat', /get_lun
readf, lun1, lon_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_sigma.dat', /get_lun
readf, lun1, slon_array
free_lun, lun1

n = sctpropsstruct.nchute

t_array = t_array(0:n-1)
height_array = height_array(0:n-1)
vrel_array = vrel_array(0:n-1) 
lat_array = lat_array(0:n-1)
lon_array = lon_array(0:n-1)
st_array = st_array(0:n-1)
sheight_array = sheight_array(0:n-1)
svrel_array = svrel_array(0:n-1) 
slat_array = slat_array(0:n-1)
slon_array = slon_array(0:n-1)


zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

!p.multi=[0,1,4]
device, xsize=4, ysize=8, /inch

xminor = 5
yminor = 5
plot, t_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 't!DSCLK!N (s) - '+t0string, $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), $
 zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0 
polyfill,  [t_array(i)-st_array(i), t_array(i)+st_array(i), $
 t_array(i+1)+st_array(i+1), t_array(i+1)-st_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, t_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'a'


xminor = 5
yminor = 5
plot, vrel_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'v!Drel!N (m s!U-1!N)', $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [vrel_array(i), vrel_array(i), vrel_array(i+1), vrel_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), $
 zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0 
polyfill,  [vrel_array(i)-svrel_array(i), vrel_array(i)+svrel_array(i), $
 vrel_array(i+1)+svrel_array(i+1), vrel_array(i+1)-svrel_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, vrel_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'b'

xminor = 5
yminor = 5
plot, lat_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'Latitude (!Uo!NN)', $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [lat_array(i), lat_array(i), lat_array(i+1), lat_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), $
 zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0 
polyfill,  [lat_array(i)-slat_array(i), lat_array(i)+slat_array(i), $
 lat_array(i+1)+slat_array(i+1), lat_array(i+1)-slat_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, lat_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'c'

xminor = 5
yminor = 5
plot, lon_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'Longitude (!Uo!NE)', $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [lon_array(i), lon_array(i), lon_array(i+1), lon_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), $
 zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0 
polyfill,  [lon_array(i)-slon_array(i), lon_array(i)+slon_array(i), $
 lon_array(i+1)+slon_array(i+1), lon_array(i+1)-slon_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], $
 color=color, noclip=0 
i=i+1
endwhile

oplot, lon_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'd'

print, t_array(n-1), st_array(n-1)
print, zkm(n-1), szkm(n-1)
print, vrel_array(n-1), svrel_array(n-1)
print, lat_array(n-1), slat_array(n-1)
print, lon_array(n-1), slon_array(n-1)

lt0 = !pi/180. * lat_array(0)
lt1 = !pi/180. * lat_array(n-1)
ln0 = !pi/180. * lon_array(0)
ln1 = !pi/180. * lon_array(n-1)

s = 2. * r0 * asin(  sqrt( sin(0.5*(lt0-lt1))^2 + cos(lt0)*cos(lt1)*sin(0.5*(ln0-ln1))^2 ) )
; http://www.cooldictionary.com/words/Spherical-distance.wikipedia
s1 = r0 * acos( sin(lt0)*sin(lt1) + cos(lt0)*cos(lt1)*cos(ln0-ln1) )
print, s/1e3, s1/1e3
endif




blah=0
if blah ne 0 then begin

; Plot rho, p, T vs z

height_array = dblarr(n)
sheight_array = height_array

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

rho_array = dblarr(nchute-ndetect)
press_array = rho_array
temp_array = rho_array
alpha_array = rho_array
ca_array = rho_array
srho_array = rho_array
spress_array = rho_array
stemp_array = rho_array
salpha_array = rho_array
sca_array = rho_array

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_nominal.dat', /get_lun
readf, lun1, alpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_sigma.dat', /get_lun
readf, lun1, salpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_ca_nominal.dat', /get_lun
readf, lun1, ca_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_ca_sigma.dat', /get_lun
readf, lun1, sca_array
free_lun, lun1

height_array = height_array(ndetect:nchute-1)
sheight_array = sheight_array(ndetect:nchute-1)

n = nchute - ndetect

;rho_array = rho_array(0:n-1) 
;press_array = press_array(0:n-1)
;temp_array = temp_array(0:n-1)
;alpha_array = alpha_array(0:n-1)
;ca_array = ca_array(0:n-1)
;srho_array = srho_array(0:n-1) 
;spress_array = spress_array(0:n-1)
;stemp_array = stemp_array(0:n-1)
;salpha_array = salpha_array(0:n-1)
;sca_array = sca_array(0:n-1)

zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

szkm(0:npadtop-1) = 0.
; don't plot uncertainties in padtop region...

!p.multi=[0,1,3]
device, xsize=4, ysize=10, /inch

xminor = -1
yminor = 5
plot, rho_array, zkm, /xlog, $
 ytitle = 'Altitude (km)', xtitle = 'Density (kg m!U-3!N)', yrange=[0,100], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor, $
 xrange=[1e-7,1e-2], /xstyle

i=0
while i lt n-1 do begin
polyfill, [rho_array(i), rho_array(i), rho_array(i+1), rho_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [rho_array(i)-srho_array(i), rho_array(i)+srho_array(i), $
 rho_array(i+1)+srho_array(i+1), rho_array(i+1)-srho_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile
oplot, rho_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, (10.)^(!x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0))), 20, 'a'

xminor = -1
yminor = 5
plot, press_array, zkm, /xlog, $
 ytitle = 'Altitude (km)', xtitle = 'Pressure (Pa)', yrange=[0,100], $
 xrange=[1e-3,1e3], /xstyle, xticks=6, $
 xtickname=['10!U-3!N', '10!U-2!N', $
 '10!U-1!N', '10!U0!N', '10!U1!N', '10!U2!N', '10!U3!N'], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor

i=0
while i lt n-1 do begin
polyfill, [press_array(i), press_array(i), press_array(i+1), press_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [press_array(i)-spress_array(i), press_array(i)+spress_array(i), $
 press_array(i+1)+spress_array(i+1), press_array(i+1)-spress_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile

oplot, press_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, (10.)^(!x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0))), 20, 'b'

xminor = 4
yminor = 5
plot, temp_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'Temperature (K)', yrange=[0,100], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor, xrange=[100,250], /xstyle
i=0
while i lt n-1 do begin
polyfill, [temp_array(i), temp_array(i), temp_array(i+1), temp_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [temp_array(i)-stemp_array(i), temp_array(i)+stemp_array(i), $
 temp_array(i+1)+stemp_array(i+1), temp_array(i+1)-stemp_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile

oplot, temp_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 20, 'c'



endif




blah=0
if blah ne 0 then begin

; Plot rho, p, T, alpha, CA vs z

height_array = dblarr(n)
sheight_array = height_array

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

rho_array = dblarr(nchute-ndetect)
press_array = rho_array
temp_array = rho_array
alpha_array = rho_array
ca_array = rho_array
srho_array = rho_array
spress_array = rho_array
stemp_array = rho_array
salpha_array = rho_array
sca_array = rho_array

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_nominal.dat', /get_lun
readf, lun1, alpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_sigma.dat', /get_lun
readf, lun1, salpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_ca_nominal.dat', /get_lun
readf, lun1, ca_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_ca_sigma.dat', /get_lun
readf, lun1, sca_array
free_lun, lun1

height_array = height_array(ndetect:nchute-1)
sheight_array = sheight_array(ndetect:nchute-1)

n = nchute - ndetect

;rho_array = rho_array(0:n-1) 
;press_array = press_array(0:n-1)
;temp_array = temp_array(0:n-1)
;alpha_array = alpha_array(0:n-1)
;ca_array = ca_array(0:n-1)
;srho_array = srho_array(0:n-1) 
;spress_array = spress_array(0:n-1)
;stemp_array = stemp_array(0:n-1)
;salpha_array = salpha_array(0:n-1)
;sca_array = sca_array(0:n-1)

zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

szkm(0:npadtop-1) = 0.
; don't plot uncertainties in padtop region...

!p.multi=[0,1,5]
device, xsize=4, ysize=10, /inch

xminor = -1
yminor = 5
plot, rho_array, zkm, /xlog, $
 ytitle = 'Altitude (km)', xtitle = 'Density (kg m!U-3!N)', yrange=[0,150], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor, $
 xrange=[1e-10,1e-2], /xstyle

i=0
while i lt n-1 do begin
polyfill, [rho_array(i), rho_array(i), rho_array(i+1), rho_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [rho_array(i)-srho_array(i), rho_array(i)+srho_array(i), $
 rho_array(i+1)+srho_array(i+1), rho_array(i+1)-srho_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile
oplot, rho_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, (10.)^(!x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0))), 100, 'a'

xminor = -1
yminor = 5
plot, press_array, zkm, /xlog, $
 ytitle = 'Altitude (km)', xtitle = 'Pressure (Pa)', yrange=[0,150], $
 xrange=[1e-5,1e3], /xstyle, xticks=6, $
 xtickname=['10!U-5!N', '10!U-4!N', '10!U-3!N', '10!U-2!N', $
 '10!U-1!N', '10!U0!N', '10!U1!N', '10!U2!N', '10!U3!N'], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor

i=0
while i lt n-1 do begin
polyfill, [press_array(i), press_array(i), press_array(i+1), press_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [press_array(i)-spress_array(i), press_array(i)+spress_array(i), $
 press_array(i+1)+spress_array(i+1), press_array(i+1)-spress_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile

oplot, press_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, (10.)^(!x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0))), 100, 'b'

xminor = 5
yminor = 5
plot, temp_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'Temperature (K)', yrange=[0,150], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = yminor, yminor = yminor, $
 xrange=[50,250], /xstyle
i=0
while i lt n-1 do begin
polyfill, [temp_array(i), temp_array(i), temp_array(i+1), temp_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [temp_array(i)-stemp_array(i), temp_array(i)+stemp_array(i), $
 temp_array(i+1)+stemp_array(i+1), temp_array(i+1)-stemp_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile

oplot, temp_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'c'

xminor = 5
yminor = 5
plot, alpha_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'Angle of Attack (degrees)', yrange=[0,150], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [alpha_array(i), alpha_array(i), alpha_array(i+1), alpha_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [alpha_array(i)-salpha_array(i), alpha_array(i)+salpha_array(i), $
 alpha_array(i+1)+salpha_array(i+1), alpha_array(i+1)-salpha_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile

oplot, alpha_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'd'

xminor = 5
yminor = 5
plot, ca_array, zkm, $
 ytitle = 'Altitude (km)', xtitle = 'C!DA!N', yrange=[0,150], $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor
i=0
while i lt n-1 do begin
polyfill, [ca_array(i), ca_array(i), ca_array(i+1), ca_array(i+1)], $
 [zkm(i)-szkm(i), zkm(i)+szkm(i), zkm(i+1)+szkm(i+1), zkm(i+1)-szkm(i+1)], $
 color=color, noclip=0
polyfill, [ca_array(i)-sca_array(i), ca_array(i)+sca_array(i), $
 ca_array(i+1)+sca_array(i+1), ca_array(i+1)-sca_array(i+1)], $
 [zkm(i), zkm(i), zkm(i+1), zkm(i+1)], color=color, noclip=0
i=i+1
endwhile

oplot, ca_array, zkm
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
xyouts, !x.crange(0) + 0.05 * (!x.crange(1) - !x.crange(0)), 100, 'e'


endif




















blah=0
if blah ne 0 then begin
; Print atm results in table

height_array = dblarr(n)
t_array = height_array
lat_array = height_array
lon_array = height_array
vrel_array = height_array
sheight_array = height_array
st_array = height_array
slat_array = height_array
slon_array = height_array
svrel_array = height_array

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

rho_array = dblarr(nchute-ndetect)
press_array = rho_array
temp_array = rho_array
alpha_array = rho_array
ca_array = rho_array
srho_array = rho_array
spress_array = rho_array
stemp_array = rho_array
salpha_array = rho_array
sca_array = rho_array

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_t_nominal.dat', /get_lun
readf, lun1, t_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_t_sigma.dat', /get_lun
readf, lun1, st_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_nominal.dat', /get_lun
readf, lun1, lat_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_sigma.dat', /get_lun
readf, lun1, slat_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_nominal.dat', /get_lun
readf, lun1, lon_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_sigma.dat', /get_lun
readf, lun1, slon_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_nominal.dat', /get_lun
readf, lun1, vrel_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_sigma.dat', /get_lun
readf, lun1, svrel_array
free_lun, lun1




openr, lun1, outdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_nominal.dat', /get_lun
readf, lun1, alpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_sigma.dat', /get_lun
readf, lun1, salpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_ca_nominal.dat', /get_lun
readf, lun1, ca_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_ca_sigma.dat', /get_lun
readf, lun1, sca_array
free_lun, lun1

ntraj = nchute
natm = nchute - ndetect
ndiff = ntraj - natm

n = ntraj

rho_array =[dblarr(ndiff),rho_array]
press_array =[dblarr(ndiff),press_array]
temp_array =[dblarr(ndiff),temp_array]
alpha_array =[dblarr(ndiff),alpha_array]
ca_array =[dblarr(ndiff),ca_array]
srho_array =[dblarr(ndiff),srho_array]
spress_array =[dblarr(ndiff),spress_array]
stemp_array =[dblarr(ndiff),stemp_array]
salpha_array =[dblarr(ndiff),salpha_array]
sca_array =[dblarr(ndiff),sca_array]

zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

xx = indgen(21) * floor((n-1)/20)

openw, lun1, 'junk1.txt', /get_lun
openw, lun2, 'junk2.txt', /get_lun
openw, lun3, 'junk3.txt', /get_lun
i=0
while i lt 21 do begin

;format = '(2F9.4,2E11.4,4F9.4,4E11.4,6F9.4,10E11.4)'

;format = '(F9.3, " $\pm$ ", F9.4)'
;format = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " \\ ")'

format1 = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.1, " $\pm$ ", F9.1, " \\ ")'

format2 = '(F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " \\ ")'

format3 = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " \\ ")'

;printf, lun1, format=format, t_array(xx(i)), st_array(xx(i))
;printf, lun1, format=format, t_array(xx(i)), zkm(xx(i)), szkm(xx(i)), $
; lat_array(xx(i)), slat_array(xx(i)), lon_array(xx(i)), slon_array(xx(i)), $
; vrel_array(xx(i)), svrel_array(xx(i)), rho_array(xx(i)), srho_array(xx(i)), $
; press_array(xx(i)), spress_array(xx(i)), temp_array(xx(i)), stemp_array(xx(i)), $
; alpha_array(xx(i)), salpha_array(xx(i)), ca_array(xx(i)), sca_array(xx(i)) 

printf, lun1, format=format1, t_array(xx(i)), zkm(xx(i)), szkm(xx(i)), $
 lat_array(xx(i)), slat_array(xx(i)), lon_array(xx(i)), slon_array(xx(i)), $
 vrel_array(xx(i)), svrel_array(xx(i)), alpha_array(xx(i)), salpha_array(xx(i))

printf, lun2, format=format2, zkm(xx(i)), szkm(xx(i)), $
 rho_array(xx(i)), srho_array(xx(i)), $
 press_array(xx(i)), spress_array(xx(i)), temp_array(xx(i)), stemp_array(xx(i)), $
 ca_array(xx(i)), sca_array(xx(i)) 

printf, lun3, format=format3, t_array(xx(i)), zkm(xx(i)), szkm(xx(i)), $
 rho_array(xx(i)), srho_array(xx(i)), $
 press_array(xx(i)), spress_array(xx(i)), temp_array(xx(i)), stemp_array(xx(i))



;s0 = strmid(strcompress(string(t_array(xx(i))), /remove_all), 0, 8)

;print, $
; t_array(xx(i)), ' $\pm$ ', st_array(xx(i)), ' & ', $
; zkm(xx(i)), ' $\pm$ ', szkm(xx(i)), ' & ', $
; lat_array(xx(i)), ' $\pm$ ', slat_array(xx(i)), ' & ', $
; lon_array(xx(i)), ' $\pm$ ', slon_array(xx(i)), ' & ', $
; vrel_array(xx(i)), ' $\pm$ ', svrel_array(xx(i)), ' & ', $
; rho_array(xx(i)), ' $\pm$ ', srho_array(xx(i)), ' & ', $
; press_array(xx(i)), ' $\pm$ ', spress_array(xx(i)), ' & ', $
; temp_array(xx(i)), ' $\pm$ ', stemp_array(xx(i)), ' & ', $
; alpha_array(xx(i)), ' $\pm$ ', salpha_array(xx(i)), ' & ', $
; ca_array(xx(i)), ' $\pm$ ', sca_array(xx(i)), ' \\ '

i=i+1
endwhile

free_lun, lun1
free_lun, lun2
free_lun, lun3

endif


blah=0
if blah ne 0 then begin
; Epsilon plot

t_array = dblarr(n)
aeroaccsctx_array = t_array
aeroaccscty_array = t_array
aeroaccsctz_array = t_array
saeroaccsctx_array = t_array
saeroaccscty_array = t_array
saeroaccsctz_array = t_array

height_array = t_array
sheight_array = t_array

openr, lun1, datafile, /get_lun
readf, lun1, t_array
readf, lun1, aeroaccsctx_array
readf, lun1, aeroaccscty_array
readf, lun1, aeroaccsctz_array
readf, lun1, saeroaccsctx_array
readf, lun1, saeroaccscty_array
readf, lun1, saeroaccsctz_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

n = sctpropsstruct.nchute

t_array = t_array(0:n-1)
aeroaccsctx_array = aeroaccsctx_array(0:n-1)
aeroaccscty_array = aeroaccscty_array(0:n-1)
aeroaccsctz_array = aeroaccsctz_array(0:n-1)
saeroaccsctx_array = saeroaccsctx_array(0:n-1)
saeroaccscty_array = saeroaccscty_array(0:n-1)
saeroaccsctz_array = saeroaccsctz_array(0:n-1)
height_array = height_array(0:n-1)
sheight_array = sheight_array(0:n-1)

zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

az = aeroaccsctz_array
saz = saeroaccsctz_array
an = sqrt(aeroaccsctx_array^2 + aeroaccscty_array^2)
sofansqd = sqrt( (2.*saeroaccsctx_array*aeroaccsctx_array)^2 + $ 
 (2.*saeroaccscty_array*aeroaccscty_array)^2 )
san = 0.5 * sofansqd / an


nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

alpha_array = dblarr(nchute-ndetect)
salpha_array = alpha_array

openr, lun1, outdir + 'atm_' + sct + '_alpha_nominal.dat', /get_lun
readf, lun1, alpha_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_alpha_sigma.dat', /get_lun
readf, lun1, salpha_array
free_lun, lun1

alpha_array =[dblarr(ndetect),alpha_array]
salpha_array =[dblarr(ndetect),salpha_array]

arad = !pi/180.*alpha_array
sarad = !pi/180.*salpha_array

;cosarad = abs(cos( arad ))
;scosarad = abs(sin(arad)) * sarad
;sinarad = abs(sin( arad ))
;ssinarad = abs(cos(arad)) * sarad
;x0 = az * cosarad
;sx0 = sqrt( cosarad^2 * saz^2 + az^2 * scosarad^2 )
;x1 = an * sinarad
;sx1 = sqrt( sinarad^2 * san^2 + an^2 * ssinarad^2 )
;x2 = x0 + x1
;sx2 = sqrt( sx0^2 + sx1^2 )
;x3 = az
;sx3 = saz
;x4 = x3 / x2
;sx4 = x4 * sqrt( (sx3/x3)^2 + (sx2/x2)^2 )
;sx5 = sqrt( (sx3/x2)^2 + (x3*sx2/x2^2)^2 )
;eps = x4 - 1
;seps = sx4
;eps = az / (az*cos(arad) + an*sin(arad)) - 1.

meps = arad*0.
seps = meps

i=0
while i lt n do begin

nlot = 1000

azlot = az(i)+saz(i)*randomn(seed,nlot)
anlot = an(i)+san(i)*randomn(seed,nlot)
aradlot = arad(i)+sarad(i)*randomn(seed,nlot)

epslot = azlot / (azlot*cos(aradlot) + anlot*sin(aradlot)) - 1.

junk = moment(epslot)
meps(i) = junk(0)
seps(i) = sqrt(junk(1))

i=i+1
endwhile

xminor = 5
yminor = 5
plot, t_array, meps, $
 ytitle = '!9e!X - 1', xtitle = 't!DSCLK!N (s) - '+t0string, $
 xtick_get = xtick_got, ytick_get = ytick_got, xminor = xminor, yminor = yminor, $
 yrange=[0.,0.015]

i=0
while i lt n-1 do begin
polyfill, [t_array(i), t_array(i), t_array(i+1), t_array(i+1)], $
 [meps(i)-seps(i), meps(i)+seps(i), meps(i+1)+seps(i+1), meps(i+1)-seps(i+1)], $
 color=color, noclip=0
i=i+1
endwhile

oplot, t_array, meps
axis, xaxis=0, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, xaxis=1, xtickname=strarr(50)+' ', xtickv = xtick_got, xticks=n_elements(xtick_got)-1, $
xminor = xminor
axis, yaxis=0, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor
axis, yaxis=1, ytickname=strarr(50)+' ', ytickv = ytick_got, yticks=n_elements(ytick_got)-1, $
yminor = yminor

fudge = 2.* (0.5*arad*arad - an/az * arad)

;openw, lun1, 'epsilon.dat', /get_lun
;printf, lun1, meps
;free_lun, lun1

endif


blah=0
if blah ne 0 then begin
; Investigate effects of alpha=0

t0 = dblarr(n)
height0 = t0
lat0 = t0
lon0 = t0
vrel0 = t0
st0 = t0
sheight0 = t0
slat0 = t0
slon0 = t0
svrel0 = t0

t1 = t0
height1 = t0
lat1 = t0
lon1 = t0
vrel1 = t0

outdir = 'output/'

openr, lun1, outdir + 'traj_' + sct + '_t_nominal.dat', /get_lun
readf, lun1, t0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_t_sigma.dat', /get_lun
readf, lun1, st0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_nominal.dat', /get_lun
readf, lun1, lat0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_sigma.dat', /get_lun
readf, lun1, slat0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_nominal.dat', /get_lun
readf, lun1, lon0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_sigma.dat', /get_lun
readf, lun1, slon0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_nominal.dat', /get_lun
readf, lun1, vrel0
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_sigma.dat', /get_lun
readf, lun1, svrel0
free_lun, lun1

otherdir = 'adjoutput/'

openr, lun1, otherdir + 'traj_' + sct + '_t_nominal.dat', /get_lun
readf, lun1, t1
free_lun, lun1

openr, lun1, otherdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height1
free_lun, lun1

openr, lun1, otherdir + 'traj_' + sct + '_lat_nominal.dat', /get_lun
readf, lun1, lat1
free_lun, lun1

openr, lun1, otherdir + 'traj_' + sct + '_lon_nominal.dat', /get_lun
readf, lun1, lon1
free_lun, lun1

openr, lun1, otherdir + 'traj_' + sct + '_vrel_nominal.dat', /get_lun
readf, lun1, vrel1
free_lun, lun1

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

t0 = t0(0:nchute-1)
height0 = height0(0:nchute-1)
vrel0 = vrel0(0:nchute-1) 
lat0 = lat0(0:nchute-1)
lon0 = lon0(0:nchute-1)
st0 = st0(0:nchute-1)
sheight0 = sheight0(0:nchute-1)
svrel0 = svrel0(0:nchute-1) 
slat0 = slat0(0:nchute-1)
slon0 = slon0(0:nchute-1)
t1 = t1(0:nchute-1)
height1 = height1(0:nchute-1)
vrel1 = vrel1(0:nchute-1) 
lat1 = lat1(0:nchute-1)
lon1 = lon1(0:nchute-1)


z0 = (height0 - sctpropsstruct.r0)/1e3
sz0 = sheight0/1e3
z1 = (height1 - sctpropsstruct.r0)/1e3


rho0 = dblarr(nchute-ndetect)
press0 = rho0
temp0 = rho0
srho0 = rho0
spress0 = rho0
stemp0 = rho0

rho1 = rho0
press1 = rho0
temp1 = rho0

openr, lun1, outdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho0
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho0
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press0
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress0
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp0
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp0
free_lun, lun1

openr, lun1, otherdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho1
free_lun, lun1

openr, lun1, otherdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press1
free_lun, lun1

openr, lun1, otherdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp1
free_lun, lun1


rho0 =[dblarr(ndetect),rho0]
press0 =[dblarr(ndetect),press0]
temp0 =[dblarr(ndetect),temp0]
srho0 =[dblarr(ndetect),srho0]
spress0 =[dblarr(ndetect),spress0]
stemp0 =[dblarr(ndetect),stemp0]
rho1 =[dblarr(ndetect),rho1]
press1 =[dblarr(ndetect),press1]
temp1 =[dblarr(ndetect),temp1]


endif


blah=0
if blah ne 0 then begin
; Print surface pressure estimate

height_array = dblarr(n)
sheight_array = height_array

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

rho_array = dblarr(nchute-ndetect)
press_array = rho_array
temp_array = rho_array
srho_array = rho_array
spress_array = rho_array
stemp_array = rho_array

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1


openr, lun1, outdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp_array
free_lun, lun1

z0 = (height_array - sctpropsstruct.r0)/1e3
sz0 = sheight_array/1e3

nlot = 1000

p0lot = press_array(nchute-ndetect-1) + spress_array(nchute-ndetect-1)*randomn(seed,nlot)
z0lot = z0(nchute-1) + sz0(nchute-1)*randomn(seed,nlot)
t0lot = temp_array(nchute-ndetect-1) + stemp_array(nchute-ndetect-1)*randomn(seed,nlot)

mean_molecular_mass = marspropsstruct.mean_molecular_mass
universal_gas_constant = marspropsstruct.universal_gas_constant
;avogadro = marspropsstruct.avogadro 
grav = marspropsstruct.gm / (sctpropsstruct.r0)^2


;h0lot = t0lot * universal_gas_constant/avogadro * 1./(mean_molecular_mass * grav)
h0lot = t0lot * universal_gas_constant * 1./(mean_molecular_mass * grav)

pslot = p0lot * exp( 1e3*z0lot/h0lot )

junk = moment(pslot)
mps = junk(0)
sps = sqrt(junk(1))

print, mps, sps
endif


blah=0
if blah ne 0 then begin
; Print hiz table of results

nblocks = sctpropsstruct.nblocks

height_array = dblarr(nblocks)
t_array = height_array
vrel_array = height_array
axial_array = height_array
sheight_array = height_array
st_array = height_array
svrel_array = height_array
saxial_array = height_array

rho_array = height_array
press_array = rho_array
temp_array = rho_array
ca_array = rho_array
srho_array = rho_array
spress_array = rho_array
stemp_array = rho_array
sca_array = rho_array

openr, lun1, outdir + 'hiz_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_t_nominal.dat', /get_lun
readf, lun1, t_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_t_sigma.dat', /get_lun
readf, lun1, st_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_vrel_nominal.dat', /get_lun
readf, lun1, vrel_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_vrel_sigma.dat', /get_lun
readf, lun1, svrel_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_axial_nominal.dat', /get_lun
readf, lun1, axial_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_axial_sigma.dat', /get_lun
readf, lun1, saxial_array
free_lun, lun1




openr, lun1, outdir + 'hiz_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_ca_nominal.dat', /get_lun
readf, lun1, ca_array
free_lun, lun1

openr, lun1, outdir + 'hiz_' + sct + '_ca_sigma.dat', /get_lun
readf, lun1, sca_array
free_lun, lun1

zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

openw, lun1, 'junk1.txt', /get_lun
openw, lun2, 'junk2.txt', /get_lun
openw, lun3, 'junk3.txt', /get_lun
i=0
while i lt nblocks do begin

;format = '(2F9.4,2E11.4,4F9.4,4E11.4,6F9.4,10E11.4)'

;format = '(F9.3, " $\pm$ ", F9.4)'
;format = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " \\ ")'

;format1 = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.2, " $\pm$ ", F9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.1, " $\pm$ ", F9.1, " \\ ")'

format1 = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " \\ ")'

format2 = '(F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " & ", F9.2, " $\pm$ ", F9.2, " \\ ")'

format3 = '(F9.3, " & ", F9.1, " $\pm$ ", F9.1, " & ", E9.2, " $\pm$ ", E9.2, " & ", E9.2, " $\pm$ ", E9.2, " & ", F9.1, " $\pm$ ", F9.1, " \\ ")'

;printf, lun1, format=format, t_array(xx(i)), st_array(xx(i))
;printf, lun1, format=format, t_array(xx(i)), zkm(xx(i)), szkm(xx(i)), $
; lat_array(xx(i)), slat_array(xx(i)), lon_array(xx(i)), slon_array(xx(i)), $
; vrel_array(xx(i)), svrel_array(xx(i)), rho_array(xx(i)), srho_array(xx(i)), $
; press_array(xx(i)), spress_array(xx(i)), temp_array(xx(i)), stemp_array(xx(i)), $
; alpha_array(xx(i)), salpha_array(xx(i)), ca_array(xx(i)), sca_array(xx(i)) 

;printf, lun1, format=format1, t_array(xx(i)), zkm(xx(i)), szkm(xx(i)), $
; lat_array(xx(i)), slat_array(xx(i)), lon_array(xx(i)), slon_array(xx(i)), $
; vrel_array(xx(i)), svrel_array(xx(i)), alpha_array(xx(i)), salpha_array(xx(i))

printf, lun1, format=format1, t_array(i), zkm(i), szkm(i), $
 axial_array(i), saxial_array(i), vrel_array(i), svrel_array(i)

printf, lun2, format=format2, zkm(i), szkm(i), $
 rho_array(i), srho_array(i), $
 press_array(i), spress_array(i), temp_array(i), stemp_array(i), $
 ca_array(i), sca_array(i) 

printf, lun3, format=format3, t_array(i), zkm(i), szkm(i), $
 rho_array(i), srho_array(i), $
 press_array(i), spress_array(i), temp_array(i), stemp_array(i)




;s0 = strmid(strcompress(string(t_array(xx(i))), /remove_all), 0, 8)

;print, $
; t_array(xx(i)), ' $\pm$ ', st_array(xx(i)), ' & ', $
; zkm(xx(i)), ' $\pm$ ', szkm(xx(i)), ' & ', $
; lat_array(xx(i)), ' $\pm$ ', slat_array(xx(i)), ' & ', $
; lon_array(xx(i)), ' $\pm$ ', slon_array(xx(i)), ' & ', $
; vrel_array(xx(i)), ' $\pm$ ', svrel_array(xx(i)), ' & ', $
; rho_array(xx(i)), ' $\pm$ ', srho_array(xx(i)), ' & ', $
; press_array(xx(i)), ' $\pm$ ', spress_array(xx(i)), ' & ', $
; temp_array(xx(i)), ' $\pm$ ', stemp_array(xx(i)), ' & ', $
; alpha_array(xx(i)), ' $\pm$ ', salpha_array(xx(i)), ' & ', $
; ca_array(xx(i)), ' $\pm$ ', sca_array(xx(i)), ' \\ '

i=i+1
endwhile

free_lun, lun1
free_lun, lun2
free_lun, lun3



endif



blah=1
if blah ne 0 then begin
; Plot all 5 entry profiles

n=39
junk = dblarr(4,n)
openr, lun1, 'vl1.dat', /get_lun
readf, lun1, junk
free_lun, lun1
; Source is Seiff and Kirk, 1977, JGR

vl1_z = transpose(junk(0,*)) * 1e3 	; m
vl1_r = transpose(junk(1,*)) 		; kg m-3
vl1_p = transpose(junk(2,*)) * 1e2	; Pa
vl1_t = transpose(junk(3,*))		; K

vl1_lat = 22.				; deg N
vl1_lon = 312.				; deg E
; Source is http://nssdc.gsfc.nasa.gov/database/MasterCatalog?sc=1975-075C

vl1_ls = 96.				; deg
; 20 Jul 1976, Source is Magalhaes et al., 1999, JGR
vl1_lst = 16.+13./60.			; hr
; Source is Seiff and Kirk, 1977, JGR

n=37
junk = dblarr(4,n)
openr, lun1, 'vl2.dat', /get_lun
readf, lun1, junk
free_lun, lun1
; Source is Seiff and Kirk, 1977, JGR

vl2_z = transpose(junk(0,*)) * 1e3	; m
vl2_r = transpose(junk(1,*))		; kg m-3
vl2_p = transpose(junk(2,*)) * 1e2	; Pa
vl2_t = transpose(junk(3,*))		; K

vl2_lat = 48.				; deg N
vl2_lon = 134.				; deg E
; Source is http://nssdc.gsfc.nasa.gov/database/MasterCatalog?sc=1975-075C
vl2_ls = 117.				; deg
; 3 Sep 1976, Source is Magalhaes et al., 1999, JGR
vl2_lst = 9.+49./60.			; hr
; Source is Seiff and Kirk, 1977, JGR

n=701
junk = dblarr(15,n)
openr, lun1, 'mpf.dat', /get_lun
readf, lun1, junk
free_lun, lun1
; Source is http://atmos.nmsu.edu/PDS/data/mpam_0001/edl_ddr/edl_ddr.tab

mpf_z = transpose(junk(2,*)) * 1e3 	; m
mpf_r = transpose(junk(5,*)) 		; kg m-3
mpf_p = transpose(junk(6,*)) * 1e2	; Pa
mpf_t = transpose(junk(7,*))		; K

mpf_sr = transpose(junk(9,*)-junk(10,*))/6.		; kg m-3
mpf_sp = transpose(junk(11,*)-junk(12,*))/6.*1e2	; Pa
mpf_st = transpose(junk(13,*)-junk(14,*))/6.		; K
; 1 sigma uncertainties
; File quotes up/downward 3-sigma widths, hence processing

mpf_lat = 19.				; deg N
mpf_lon = 326.				; deg E
mpf_ls = 143.				; deg
; 4 July 1997
mpf_lst = 2. + 58/60.			; hr
; Source is Magalhaes et al., 1999, JGR


nspi=904
heightspi = dblarr(nspi)
sheightspi = heightspi
pressspi = heightspi
spressspi = heightspi
tempspi = heightspi
stempspi = heightspi
r0spi = double(3392.3e3) ; MER-2 from MOLA/NSSDC

openr, lun1, 'output/atm_mer2_height_nominal.dat', /get_lun
readf, lun1, heightspi
free_lun, lun1

openr, lun1, 'output/atm_mer2_height_sigma.dat', /get_lun
readf, lun1, sheightspi
free_lun, lun1

openr, lun1, 'output/atm_mer2_press_nominal.dat', /get_lun
readf, lun1, pressspi
free_lun, lun1

openr, lun1, 'output/atm_mer2_press_sigma.dat', /get_lun
readf, lun1, spressspi
free_lun, lun1

openr, lun1, 'output/atm_mer2_temp_nominal.dat', /get_lun
readf, lun1, tempspi
free_lun, lun1

openr, lun1, 'output/atm_mer2_temp_sigma.dat', /get_lun
readf, lun1, stempspi
free_lun, lun1

zkmspi = (heightspi-r0spi)/1e3
szkmspi = (sheightspi)/1e3


nopp=901
heightopp = dblarr(nopp)
sheightopp = heightopp
pressopp = heightopp
spressopp = heightopp
tempopp = heightopp
stempopp = heightopp
r0opp = double(3394.1e3) ; MER-1

openr, lun1, 'output/atm_mer1_height_nominal.dat', /get_lun
readf, lun1, heightopp
free_lun, lun1

openr, lun1, 'output/atm_mer1_height_sigma.dat', /get_lun
readf, lun1, sheightopp
free_lun, lun1

openr, lun1, 'output/atm_mer1_press_nominal.dat', /get_lun
readf, lun1, pressopp
free_lun, lun1

openr, lun1, 'output/atm_mer1_press_sigma.dat', /get_lun
readf, lun1, spressopp
free_lun, lun1

openr, lun1, 'output/atm_mer1_temp_nominal.dat', /get_lun
readf, lun1, tempopp
free_lun, lun1

openr, lun1, 'output/atm_mer1_temp_sigma.dat', /get_lun
readf, lun1, stempopp
free_lun, lun1

zkmopp = (heightopp-r0opp)/1e3
szkmopp = (sheightopp)/1e3

;plot, [0], [0], xrange=[50,250], yrange=[1000,0.1], /ylog, /ystyle, $
plot, [0], [0], xrange=[100,250], yrange=[1000,0.1]*1e-2, /ylog, /ystyle, $
 title = title, xtitle = 'Temperature (K)', $
 ytitle = 'Pressure (Pa)', yminor=-1, yticks=4, $
 ytickname=['10!U3', '10!U2', '10!U1', '10!U0', '10!U-1']

;plot, [0,500], [100.,0.01], /nodata, /xstyle, /ystyle, /ylog

tempopp = smooth(tempopp,5,/edge_truncate)
tempspi = smooth(tempspi,5,/edge_truncate)
mpf_t = smooth(mpf_t,5,/edge_truncate)

!p.thick=5
oplot, tempopp, pressopp*1e-2, color=0, linestyle=1
oplot, tempspi, pressspi*1e-2, color=0, linestyle=2
oplot, mpf_t, mpf_p*1e-2, color=0
;oplot, vl1_t-50, vl1_p*1e-2, psym=-6
;oplot, vl2_t-50, vl2_p*1e-2, psym=-5
oplot, vl1_t-00, vl1_p*1e-2, psym=-6
oplot, vl2_t-00, vl2_p*1e-2, psym=-5



levels = dindgen(15)*5.+10.
i=0
;while i lt n_elements(levels) do begin
while i lt -1 do begin
aa = where( abs(zkmspi-levels(i)) eq min(abs(zkmspi-levels(i))) )
aa= aa(0)
oplot, tempspi(aa) * [1,1], (pressspi(aa) + spressspi(aa) * [-1,1])*1e-2, color=7
oplot, tempspi(aa) + stempspi(aa) * [-1,1], (pressspi(aa) * [1,1])*1e-2, color=7
aa = where( abs(zkmopp-levels(i)) eq min(abs(zkmopp-levels(i))) )
aa= aa(0)
oplot, tempopp(aa) * [1,1], (pressopp(aa) + spressopp(aa) * [-1,1])*1e-2, color=6
oplot, tempopp(aa) + stempopp(aa) * [-1,1], (pressopp(aa) * [1,1])*1e-2, color=6
;aa = where( abs(mpf_z/1e3-levels(i)) eq min(abs(mpf_z/1e3-levels(i))) )
;aa= aa(0)
;oplot, mpf_t(aa) * [1,1], (mpf_p(aa) + mpf_sp(aa) * [-1,1]), color=8
;oplot, mpf_t(aa) + mpf_st(aa) * [-1,1], (mpf_p(aa) * [1,1]), color=8
i=i+1
endwhile

;xyouts, 180, 0.2*1e-2, 'Spirit', color=2
;xyouts, 180, 0.4*1e-2, 'Opportunity', color=1
;xyouts, 180, 0.8*1e-2, 'Pathfinder', color=3
;;xyouts, 70, 100*1e-2, 'Square = VL1 - 50K'
;;xyouts, 70, 200*1e-2, 'Triangle = VL2 - 50K'
;xyouts, 105, 100*1e-2, 'Square = VL1'
;xyouts, 105, 200*1e-2, 'Triangle = VL2'





endif



blah=0
if blah ne 0 then begin
; Plot T(p) vs TES
n = nchute-ndetect

height = dblarr(n)
sheight = height
press = height
spress = height
temp = height
stemp = height
;r0 = double(3394.1e3) ; MER-1

openr, lun1, 'output/atm_'+sct+'_height_nominal.dat', /get_lun
readf, lun1, height
free_lun, lun1

openr, lun1, 'output/atm_'+sct+'_height_sigma.dat', /get_lun
readf, lun1, sheight
free_lun, lun1

openr, lun1, 'output/atm_'+sct+'_press_nominal.dat', /get_lun
readf, lun1, press
free_lun, lun1

openr, lun1, 'output/atm_'+sct+'_press_sigma.dat', /get_lun
readf, lun1, spress
free_lun, lun1

openr, lun1, 'output/atm_'+sct+'_temp_nominal.dat', /get_lun
readf, lun1, temp
free_lun, lun1

openr, lun1, 'output/atm_'+sct+'_temp_sigma.dat', /get_lun
readf, lun1, stemp
free_lun, lun1

zkm = (height-r0)/1e3
szkm = (sheight)/1e3

levels = dindgen(15)*5.+10.
i=0
while i lt n_elements(levels) do begin
aa = where( abs(zkm-levels(i)) eq min(abs(zkm-levels(i))) )
aa= aa(0)
;oplot, press(aa) + spress(aa) * [-1,1], zkm(aa) * [1,1], color=1
;oplot, press(aa) * [1,1], zkm(aa) + szkm(aa) * [-1,1], color=1
i=i+1
endwhile

if sct eq 'mer1' then begin
tesfile = '../compdata/TESdataMER.Meridiani'
dataarr = dblarr(26,20)
endif

if sct eq 'mer2' then begin
tesfile = '../compdata/TESdataMER.Gusev'
dataarr = dblarr(26,21)
endif

junk=''
openr, lun1, tesfile, /get_lun
readf, lun1, junk
readf, lun1, dataarr
free_lun, lun1

pressures = [16.5815200, 12.9137000, 10.0572000, 7.8325550, 6.1000000, 4.7506850, 3.6998370, 2.8814360, 2.2440650, 1.7476790, 1.3610940, 1.0600210, 0.8255452, 0.6429352, 0.5007185, 0.3899599, 0.3037011, 0.2365227, 0.1842040, 0.1434582, 0.1117254, 0.0870000, 0.0678000, 0.0528000, 0.0411000, 0.0320000, 0.0249000, 0.0194000, 0.0151000, 0.0118000, 0.0091700, 0.0071400, 0.0055600, 0.0043300, 0.0033700, 0.0026300, 0.0020500, 0.0015900] ; mbar

tesdata = dataarr(9:*,*)

pressures = pressures(4:20)
x = size(tesdata)
n = x(2)
plot, [0], [0], xrange=[160,240], yrange=[1000,10], /ylog, /ystyle, $
 title = title, xtitle = 'Temperature (K)', $
 ytitle = 'Pressure (Pa)', yminor=0, yticks=2, $
 ytickname=['10!U3', '10!U2', '10!U1'];, '10!U0']

i=0
while i lt n do begin
aa = where(tesdata(*,i) ge 0.)
oplot, tesdata(aa,i), pressures(aa)*1e2 ;, linestyle=2
if i eq (n-1)/2 then oplot, tesdata(aa,i), pressures(aa)*1e2;, psym=-1 ;, color=3
;if i eq (n-1)/2 then oplot, tesdata(aa,i)+10, pressures(aa), psym=-1, color=3
;wait, 0.2
i=i+1
endwhile

oplot, smooth(temp,5,/edge_truncate), smooth(press,5,/edge_truncate) * 1e-2*1e2, $
 thick=5
;, color=1 ; 1 mbar = 100 Pa

levels = dindgen(15)*5.+10.
i=0
;while i lt n_elements(levels) do begin
while i lt -1 do begin
aa = where( abs(zkm-levels(i)) eq min(abs(zkm-levels(i))) )
aa= aa(0)
oplot, temp(aa) * [1,1], (press(aa) + spress(aa) * [-1,1])*1e-2*1e2, color=2
oplot, temp(aa) + stemp(aa) * [-1,1], (press(aa) * [1,1])*1e-2*1e2, color=2
i=i+1
endwhile

device, /close

set_plot, 'x'
!p.thick=1
!x.thick=1
!y.thick=1
!p.multi=0

smerp = smooth(press,5,/edge_truncate)
smert = smooth(temp,5,/edge_truncate)
i = (n-1)/2 
aa = where(tesdata(*,i) ge 0.)
stest = interpol( tesdata(aa,i), alog(pressures(aa)*1e2), alog(smerp))
cc = where(smerp gt 30. and smerp lt 200.)
plot, smert(cc), smerp(cc), yrange=[1e3,1], /ylog
oplot, stest(cc), smerp(cc)

stest = stest(cc)
smert = smert(cc)
smerp = smerp(cc)
lnsmerp = alog(smerp)
print, 'Log-p weighted mean T-MER - T-TES '
print, 'Between 30 and 200 Pa = '
print, int_tabulated( lnsmerp, (smert-stest)) / int_tabulated( lnsmerp, (smert-stest)*0.+1.)
wait,2
plot, smert, lnsmerp, /ynozero
oplot, stest, lnsmerp

;xyouts, 200, 0.02, 'Opportunity'
;xyouts, 200, 0.13, 'Blue line: TES data!Cnear EDL'
;xyouts, 200, 0.2, 'Black lines: TES data!C+/-10 days of EDL'
;xyouts, 200, 0.3, 'Red line: MER data'
;xyouts, 200, 0.03, 'Blue line: TES data!Cnear EDL'
;xyouts, 200, 0.08, 'Black lines: TES data!C+/-10 days of EDL'
;xyouts, 200, 0.2, 'Red line: MER data'

set_plot, 'ps'
endif


blah=0
if blah ne 0 then begin
n=61
zkm = dindgen(n) ; 0 - 60 km
zm = zkm * 1e3 ; z in m

temp = 200. ; T = 200 K
grav = 3.7 ; g = 3.7 ms-2
kbol = 1.38e-23 ; Boltz const
mmw = 44. * 1.67e-27 ; mass of CO2 molecule in kg
area = 5 ; m2
mass = 800 ; kg

dsh = kbol* temp / (mmw*grav)

p0 = 6 * 1e2 ; 6 mbar = 6e-3 bar = 6e-3 * 1e5 Pa = 6e2 Pa
press = p0 * exp( -zm/dsh)

rho = press / (grav * dsh)

m = 20000l
dt = 0.005 ; sec
gamma = 15*!pi/180. ; 15 deg below horiz

alpha = 5.*!pi/180. ; 5 deg angle of attack

alphascale = 15.*!pi/180.
ca = 2. - 0.2 * (alpha / alphascale)^2
cn = 0.04 * 2. * alpha/alphascale

alphafactor = cos(alpha) + cn/ca * sin(alpha)

zactual = dblarr(m)
aactual = zactual 
vactual = zactual 

zaxial = dblarr(m)
aaxial = zaxial
vaxial = zaxial
rhoaxial = zaxial
pressaxial = zaxial

tarray = zaxial

rhoactual = zaxial

zpara = zaxial
apara = zpara
vpara = zpara
rhopara = zpara
presspara = zpara


zaxial(0) = 60e3 ; 60 km
vaxial(0) = 5e3 ; 5000 ms-1

zpara(0) = zaxial(0)
vpara(0) = vaxial(0)

zactual(0) = zaxial(0)
vactual(0) = vaxial(0)

i=0
rhoactual(i) = exp(interpol( alog(rho), zm, zaxial(i) ) )
pressaxial(i) = exp(interpol( alog(press), zm, zaxial(i) ) )
presspara(i) = pressaxial(i)

aaxial(i) = ( rhoactual(i) * vaxial(i)^2 ) * area/mass * (ca/2.)
apara(i) = aaxial(i) * cos(alpha)

rhoaxial(i) = mass/area * aaxial(i)/vaxial(i)^2 * (2./ca)
rhopara(i) = mass/area * aaxial(i)/vpara(i)^2 * (2./ca)

i=i+1

while i lt m do begin

zactual(i) = zactual(i-1) - vactual(i-1) * sin(gamma) * dt
vactual(i) = vactual(i-1) - aactual(i-1) * dt

zaxial(i) = zaxial(i-1) - vaxial(i-1) * sin(gamma) * dt
vaxial(i) = vaxial(i-1) - aaxial(i-1) * dt

zpara(i) = zpara(i-1) - vpara(i-1) * sin(gamma) * dt
vpara(i) = vpara(i-1) - apara(i-1) * dt

rhoactual(i) = exp(interpol( alog(rho), zm, zaxial(i) ) )

aactual(i) = ( rhoactual(i) * vactual(i)^2 ) * area/mass * (ca/2.) * alphafactor
; actual acc along vrel vector

aaxial(i) = aactual(i) / alphafactor
apara(i) = aaxial(i) * alphafactor

rhoaxial(i) = mass/area * aaxial(i)/vaxial(i)^2 * (2./ca)
rhopara(i) = mass/area * apara(i)/vpara(i)^2 * (2./(ca*alphafactor))

pressaxial(i) = pressaxial(i-1) - rhoaxial(i-1)*grav* (zaxial(i)-zaxial(i-1)) 
presspara(i) = presspara(i-1) - rhopara(i-1)*grav* (zpara(i)-zpara(i-1)) 

tarray(i) = tarray(i-1) + dt
i=i+1
endwhile

tempaxial = pressaxial/rhoaxial * mmw/kbol
temppara = presspara/rhopara * mmw/kbol


endif



blah=0
if blah ne 0 then begin
; Print conditions at parachute deployment
; Traj and atmo

t_array = dblarr(n)
height_array = t_array
vrel_array = t_array
lat_array = t_array
lon_array = t_array
st_array = t_array
sheight_array = t_array
svrel_array = t_array
slat_array = t_array
slon_array = t_array

nchute = sctpropsstruct.nchute
ndetect = sctpropsstruct.ndetect

rho_array = dblarr(nchute-ndetect)
press_array = rho_array
temp_array = rho_array
srho_array = rho_array
spress_array = rho_array
stemp_array = rho_array

openr, lun1, outdir + 'traj_' + sct + '_t_nominal.dat', /get_lun
readf, lun1, t_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_t_sigma.dat', /get_lun
readf, lun1, st_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_nominal.dat', /get_lun
readf, lun1, height_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_height_sigma.dat', /get_lun
readf, lun1, sheight_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_nominal.dat', /get_lun
readf, lun1, vrel_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_vrel_sigma.dat', /get_lun
readf, lun1, svrel_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_nominal.dat', /get_lun
readf, lun1, lat_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lat_sigma.dat', /get_lun
readf, lun1, slat_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_nominal.dat', /get_lun
readf, lun1, lon_array
free_lun, lun1

openr, lun1, outdir + 'traj_' + sct + '_lon_sigma.dat', /get_lun
readf, lun1, slon_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_nominal.dat', /get_lun
readf, lun1, rho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_rho_sigma.dat', /get_lun
readf, lun1, srho_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_nominal.dat', /get_lun
readf, lun1, press_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_press_sigma.dat', /get_lun
readf, lun1, spress_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_nominal.dat', /get_lun
readf, lun1, temp_array
free_lun, lun1

openr, lun1, outdir + 'atm_' + sct + '_temp_sigma.dat', /get_lun
readf, lun1, stemp_array
free_lun, lun1

n = sctpropsstruct.nchute

t_array = t_array(0:n-1)
height_array = height_array(0:n-1)
vrel_array = vrel_array(0:n-1) 
lat_array = lat_array(0:n-1)
lon_array = lon_array(0:n-1)
st_array = st_array(0:n-1)
sheight_array = sheight_array(0:n-1)
svrel_array = svrel_array(0:n-1) 
slat_array = slat_array(0:n-1)
slon_array = slon_array(0:n-1)

zkm = (height_array - r0)/1e3
szkm = sheight_array/1e3

print, 'Conditions at parachute deployment'
print, ' t, z, vrel, lat, lon, sz, svrel, slat, slon'
print, t_array(n-1)
print, zkm(n-1)
print, vrel_array(n-1)
print, lat_array(n-1)
print, lon_array(n-1)
print, szkm(n-1)
print, svrel_array(n-1)
print, slat_array(n-1)
print, slon_array(n-1)
print, ''
print, 'rho, press, temp, srho, %srho, spress, %spress, stemp, %stemp'
print, rho_array(nchute-ndetect-1)
print, press_array(nchute-ndetect-1)
print, temp_array(nchute-ndetect-1)
print, srho_array(nchute-ndetect-1)
print, srho_array(nchute-ndetect-1)/rho_array(nchute-ndetect-1)
print, spress_array(nchute-ndetect-1)
print, spress_array(nchute-ndetect-1)/press_array(nchute-ndetect-1)
print, stemp_array(nchute-ndetect-1)
print, stemp_array(nchute-ndetect-1)/temp_array(nchute-ndetect-1)

endif

blah=0
if blah ne 0 then begin
; Plot TES tau dust vs Ls

n=57
junk=''
dataarr = dblarr(7,n)
openr, lun1, '../compdata/TESdust.Meridiani', /get_lun
readf, lun1, junk
readf, lun1, dataarr
free_lun, lun1

tau_merb = dataarr(5,*)
ls_merb = dataarr(1,*)
lon_merb = dataarr(3,*)

openr, lun1, '../compdata/TESdust.Gusev', /get_lun
readf, lun1, junk
readf, lun1, dataarr
free_lun, lun1

tau_mera = dataarr(5,*)
ls_mera = dataarr(1,*)
lon_mera = dataarr(3,*)

plot, ls_merb, tau_merb, psym=-1, $
 xrange=[305, 345],  xticks=7, ytitle='TES IR Dust Opacity', $
 xtickv=[311.7, 315.8, 319.8, 323.7, 327.6, 331.5, 335.3, 339.0], $
 xtickname=['07!CDec', '14!CDec', '21!CDec', '28!CDec', $
 '04!CJan', '11!CJan', '18!CJan', '25!CJan'], thick=5
oplot, ls_mera, tau_mera, psym=-4, thick=5
oplot, [1,1]*327.7, [0.6, 0.8], thick=10
oplot, [1,1]*339.1, [0.6, 0.8], thick=10
xyouts, 325, 0.82, 'Spirit'
xyouts, 332, 0.82, 'Opportunity'

aa = where(ls_merb ge 322.5 and ls_merb le 330.)
l = ls_merb(aa)
t = tau_merb(aa)
;plot, l, alog(t), psym=-1
result = poly_fit(l, alog(t), 1)
;oplot, l, result(0)+result(1)*l
print, result
;       23.930111
;    -0.075463361
print, 1./result(1)
;      -13.251464

lsa = 327.7
lsb = 339.1

aa = where(abs(lsa-ls_mera) eq min(abs(lsa-ls_mera)))
print, 'tau at A during EDL of A ', tau_mera(aa)
aa = where(abs(lsa-ls_merb) eq min(abs(lsa-ls_merb)))
print, 'tau at B during EDL of A ', tau_merb(aa)
aa = where(abs(lsb-ls_mera) eq min(abs(lsb-ls_mera)))
print, 'tau at A during EDL of B ', tau_mera(aa)
aa = where(abs(lsb-ls_merb) eq min(abs(lsb-ls_merb)))
print, 'tau at B during EDL of B ', tau_merb(aa)

endif


blah=0
if blah ne 0 then begin
; Plot sensitivity T(z)

tnom = dblarr(nchute-ndetect)
znom = tnom
ta = tnom
tb = tnom
tc = tnom
td = tnom
te = tnom
za = tnom
zb = tnom
zc = tnom
zd = tnom
ze = tnom
sensdir = 'sensstudies/'

openr, lun1, sensdir + sct + 'nominal' + 't' + '.dat', /get_lun
readf, lun1, tnom
free_lun, lun1
openr, lun1, sensdir + sct + 'nominal' + 'z' + '.dat', /get_lun
readf, lun1, znom
free_lun, lun1
openr, lun1, sensdir + sct + 'casea' + 't' + '.dat', /get_lun
readf, lun1, ta
free_lun, lun1
openr, lun1, sensdir + sct + 'casea' + 'z' + '.dat', /get_lun
readf, lun1, za
free_lun, lun1
openr, lun1, sensdir + sct + 'caseb' + 't' + '.dat', /get_lun
readf, lun1, tb
free_lun, lun1
openr, lun1, sensdir + sct + 'caseb' + 'z' + '.dat', /get_lun
readf, lun1, zb
free_lun, lun1
openr, lun1, sensdir + sct + 'casec' + 't' + '.dat', /get_lun
readf, lun1, tc
free_lun, lun1
openr, lun1, sensdir + sct + 'casec' + 'z' + '.dat', /get_lun
readf, lun1, zc
free_lun, lun1
openr, lun1, sensdir + sct + 'cased' + 't' + '.dat', /get_lun
readf, lun1, td
free_lun, lun1
openr, lun1, sensdir + sct + 'cased' + 'z' + '.dat', /get_lun
readf, lun1, zd
free_lun, lun1
openr, lun1, sensdir + sct + 'casee' + 't' + '.dat', /get_lun
readf, lun1, te
free_lun, lun1
openr, lun1, sensdir + sct + 'casee' + 'z' + '.dat', /get_lun
readf, lun1, ze
free_lun, lun1

plot, tnom, (znom-r0)/1e3, xrange=[150,300], yrange=[0,50], $
 ytitle='Altitude (km)', xtitle ='Temperature (K)'
oplot, ta, (za-r0)/1e3
oplot, tb, (zb-r0)/1e3
oplot, tc, (zc-r0)/1e3
oplot, td, (zd-r0)/1e3
oplot, te, (ze-r0)/1e3

;help, ta
;i=980
;print, tnom(i), ta(i), tb(i), tc(i), td(i), te(i)

endif


device, /close

set_plot, 'x'
!p.thick=1
!x.thick=1
!y.thick=1
!p.multi=0

stop
end
