pro setup_arrays, n

; Paul Withers, 2001.08.03
; Open University, Britain

; Called by:				recon_traj.pro, model_atm.pro
; Calls:				N/A
; Uses common blocks:			declare_array
; Reads from:				N/A
; Writes to:				N/A
; Options:				N/A
; Purpose:				Create many empty arrays to store 
; 					results of trajectory reconstruction

common declare_arrays

; Frames are defined in Withers et al., 2003
x_array = dblarr(n)
y_array = x_array
z_array = x_array
; Position in inertial cartesian frame, m
vx_array = x_array
vy_array = x_array
vz_array = x_array
; Velocity in inertial cartesian frame, ms-1
height_array = x_array 
; height_array actually refers to radial distance
; Subtract reference distance later when plotting
lat_array = x_array
lon_array = x_array
; Position in momentary spherical frame, in m, degN, degE
vxrel_array = x_array
vyrel_array = x_array
vzrel_array = x_array
; Velocity relative to atmosphere in inertial cartesian frame, ms-1
aeroacc_array = x_array
; Magnitude of aerodynamic acceleration, ms-2
vrel_array = x_array
; Magnitude of velocity relative to atmosphere, ms-1
aeroaccinex_array = x_array
aeroacciney_array = x_array
aeroaccinez_array = x_array
; Aerodynamic accelerations transformed into inertial cartesian frame, ms-2

vwind_array = dblarr(3,n)
; Wind velocity (due to planetary rotation) at spacecraft in 
; inertial cartesian frame, ms-1
g_array = vwind_array
; Gravitational acceleration at spacecraft in inertial cartesian frame, ms-2


return
end
