pro update_arrays, i, something

; Paul Withers, 2001.08.03
; Open University, Britain

; Called by:			recon_traj.pro, model_atm.pro
; Calls:			N/A
; Uses common blocks:		declare_arrays
; Reads from:			N/A
; Writes to:			N/A
; Options:			N/A
; Purpose:			Increment various arrays after one timestep of
; 				integration

common declare_arrays

vwind_array(*,i) = something(6:8)
; store wind velocity in inertial cartesian frame at current position, ms-1
vxrel_array(i) = something(9)
vyrel_array(i) = something(10)
vzrel_array(i) = something(11)
; store spacecraft velocity relative to atmosphere in inertial cartesian 
; frame, ms-1
aeroacc_array(i) = something(12) ; ms-2
vrel_array(i) = something(13) ; ms-1
; store magnitudes of aerodynamic acceleration and relative velocity
aeroaccinex_array(i) = something(14)
aeroacciney_array(i) = something(15)
aeroaccinez_array(i) = something(16)
; store xyz components of aerodynamic acceleration in inertial cartesian 
; frame, ms-2
g_array(*,i) = something(17:19)
; store acceleration due to gravity in inertial cartesian frame at 
; spacecraft position, ms-2

return
end
